import { InjectionToken } from '@angular/core';
import { Subject } from 'rxjs';
export declare type ParamDefType = 'boolean' | 'array' | 'number' | 'string';
declare type QueryParamParams<QueryParams = any> = {
    queryKey: keyof QueryParams & string;
    path?: string;
    type?: ParamDefType;
    trigger?: 'change' | 'submit';
    strategy?: 'modelToUrl' | 'twoWay';
};
export declare class QueryParamDef<QueryParams = any> {
    private config;
    constructor(config: QueryParamParams<QueryParams>);
    get queryKey(): keyof QueryParams & string;
    get path(): string;
    get type(): ParamDefType;
    get trigger(): "change" | "submit";
    get strategy(): "modelToUrl" | "twoWay";
    parse(queryParamValue: string): any;
}
export declare class BindQueryParamsManager<T = any> {
    update: Subject<void>;
    update$: import("rxjs").Observable<void>;
    defs: QueryParamDef<T>[];
    constructor(defs: QueryParamParams<T>[] | QueryParamDef<T>);
    getDef(queryKey: keyof T): QueryParamDef<T>;
    parse(queryParams: Partial<Record<keyof T, string>>): {};
}
export interface BindQueryParamsOptions {
    windowRef: Window;
}
export declare const BIND_QUERY_PARAMS_OPTIONS: InjectionToken<{
    windowRef: Window & typeof globalThis;
}>;
export {};
